<?php
  class dbMssql extends ADb{
      
           protected $dbType='Mssql';     
      
           public function connect($dbHost,$dbUser,$dbPass,$dbName=false){
                $this->dbhost=$dbHost;
                $this->dbuser=$dbUser;
                $this->dbpass=$dbPass;
                if ($this->check_exists('mssql_connect')) 
                $this->link=@mssql_connect($dbHost,$dbUser,$dbPass,true);
                if(!$this->link) $this->error('Connection Error : '.$dbHost);
                if ($dbName){
                    $this->select_db($dbName);
                }
                return $this->link;

           }
           
           public function select_db($dbName){
                 $this->dbname=$dbName;
                 @mssql_select_db($dbName,$this->link);
           }
      
           public function  query($sql){
                parent::query($sql);
                $this->lastQuery=@mssql_query($this->lastSQL,$this->link);
                if(!$this->lastQuery) $this->error('Query Error : '.$this->lastSQL); 
           }
           
           public function error($msg){
                echo  $msg.' '.@mssql_get_last_message();
           }
           
           
           public function fetch_assoc($query=false){
                    return @mssql_fetch_assoc($query ? $query : $this->lastQuery);
           }
           
           public function fetch_row($query=false){
                   return @mssql_fetch_row($query ? $query:$this->lastQuery);
           }
           
           public function fetch_object($query=false){
                  return @mssql_fetch_object($query?$query:$this->lastQuery);
           }
           
           public function fetch_all($query=false){
               $all=array();  
               while ($alls=$this->fetch_assoc()){
                   $all[]=$alls;
               }
               return $all;
           }
           public function free($query=false){
               return @mssql_free_result($query?$query:$this->lastQuery);
           }
           function close(){
               return @mssql_close($this->link);
           }
           
           function drop_table($tableName){
              return $this->query('DROP TABLE '.$tableName);
           }
           
           function drop_fields($tableName,$fieldNames){
                 return $this->query('ALTER TABLE '.$tableName.' drop ('.(is_array($fieldNames)?implode(',',$fieldNames) :$fieldNames).')');
           }
                                       
  }    
?>