<?php
  class dbMysql extends ADb{
      
           protected $dbType='Mysql';     
      
           public function connect($dbHost,$dbUser,$dbPass,$dbName=false){
                $this->dbhost=$dbHost;
                $this->dbuser=$dbUser;
                $this->dbpass=$dbPass;
                if ($this->check_exists('mysql_connect'))
                $this->link=@mysql_connect($dbHost,$dbUser,$dbPass);
                if(!$this->link)$this->error('Connection Error : '.$dbHost);
                if ($dbName){
                    $this->select_db($dbName);
                }
                return $this->link;

           }
           
           public function select_db($dbName){
                 $this->dbname=$dbName;
                 @mysql_select_db($dbName,$this->link);
           }
      
           public function  query($sql){
                parent::query($sql);
                return $this->lastQuery=@mysql_query($this->lastSQL,$this->link)  OR $this->error('Query Error : '.$this->lastSQL); 
           }
           
           public function error($msg){
                echo parent::error($msg.' ['.$this->mysql_errno().'] : '.$this->mysql_error());
           }
           
           private function mysql_errno(){
               return  @mysql_errno($this->link);
           }
            
           private function mysql_error(){
               return @mysql_error($this->link);
           }
           
           public function fetch_assoc($query=false){
                    return @mysql_fetch_assoc($query ? $query : $this->lastQuery);
           }
           
           public function fetch_row($query=false){
                   return @mysql_fetch_row($query ? $query:$this->lastQuery);
           }
           
           public function fetch_object($query=false){
                  return @mysql_fetch_object($query?$query:$this->lastQuery);
           }
           
           public function fetch_all($query=false){
               $all=array();  
               while ($alls=$this->fetch_assoc()){
                  $all[]=$alls; 
               }
               return $all;
           }
           public function free($query=false){
               return @mysql_free_result($query?$query:$this->lastQuery);
           }
           public function close(){
               return @mysql_close($this->link);
           }
           
           /**
             * Check if a table exists in a database.
             *
             * @param string The table name.
             * @return boolean True when exists, false if not.
             */
            function table_exists($table)
            {   
                $query = $this->query("
                    SHOW TABLES 
                    LIKE '{$table}'
                ");
                $exists = $this->num_rows($query);
                if($exists > 0)
                {
                    return true;
                }
                else                   
                {
                    return false;
                }
            }

            /**
             * Check if a field exists in a database.
             *
             * @param string The field name.
             * @param string The table name.
             * @return boolean True when exists, false if not.
             */
            function field_exists($field, $table)
            {
                $query = $this->query("
                    SHOW COLUMNS 
                    FROM {$table} 
                    LIKE '{$field}'
                ");
                $exists = $this->num_rows($query);
                
                if($exists > 0)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
           
           function drop_table($tableName){
              return $this->query('DROP TABLE '.$tableName);
           }
           
           function drop_fields($tableName,$fieldNames){
                 return $this->query('ALTER TABLE '.$tableName.' drop ('.(is_array($fieldNames)?implode(',',$fieldNames) :$fieldNames).')');
           }
                                       
  }    
?>