<?php
  class dbMysqli extends ADb{
      
           protected $dbType='Mysqli';     
      
           public function connect($dbHost,$dbUser,$dbPass,$dbName=false){
                $this->dbhost=$dbHost;
                $this->dbuser=$dbUser;
                $this->dbpass=$dbPass;
                if ($this->check_exists('mysqli_connect')) 
                $this->link=@mysqli_connect($dbHost,$dbUser,$dbPass);
                if(!$this->link) $this->error('Connection Error : '.$dbHost);
                if ($dbName){
                    $this->select_db($dbName);
                }
                return $this->link;

           }
           
           public function select_db($dbName){
                 $this->dbname=$dbName;
                 @mysqli_select_db($dbName,$this->link);
           }
      
           public function  query($sql){
                parent::query($sql);
                $this->lastQuery=@mysqli_query($this->lastSQL,$this->link);
                if(!$this->lastQuery) $this->error('Query Error : '.$this->lastSQL); 
                return $this->lastQuery;
           }
           
           public function error($msg){
                echo  $msg.' '.$this->mysqli_errno().' : '.$this->mysqli_error();
           }
           
           /**
             * Check if a table exists in a database.
             *
             * @param string The table name.
             * @return boolean True when exists, false if not.
             */
            function table_exists($table)
            {   
                $query = $this->query("
                    SHOW TABLES 
                    LIKE '{$table}'
                ");
                $exists = $this->num_rows($query);
                if($exists > 0)
                {
                    return true;
                }
                else                   
                {
                    return false;
                }
            }

            /**
             * Check if a field exists in a database.
             *
             * @param string The field name.
             * @param string The table name.
             * @return boolean True when exists, false if not.
             */
            function field_exists($field, $table)
            {
                $query = $this->query("
                    SHOW COLUMNS 
                    FROM {$table} 
                    LIKE '{$field}'
                ");
                $exists = $this->num_rows($query);
                
                if($exists > 0)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
           
           public function num_rows($query=false){
               return @mysql_num_rows($query?$query:$this->lastQuery);
           }
           
           private function mysqli_errno(){
               return  @mysqli_errno($this->link);
           }
            
           private function mysqli_error(){
               return @mysqli_error($this->link);
           }
           
           public function fetch_assoc($query=false){
                    return @mysqli_fetch_assoc($query ? $query : $this->lastQuery);
           }
           
           public function fetch_row($query=false){
                   return @mysqli_fetch_row($query ? $query:$this->lastQuery);
           }
           
           public function fetch_object($query=false){
                  return @mysqli_fetch_object($query?$query:$this->lastQuery);
           }
           
           public function fetch_all($query=false){
               $all=array();  
               while ($all[]=$this->fetch_assoc());
               return $all;
           }
           
           public function free($query=false){
               return @mysqli_free_result($query?$query:$this->lastQuery);
           }
           public function close(){
               return @mysqli_close($this->link);
           }
           
           function drop_table($tableName){
              return $this->query('DROP TABLE '.$tableName);
           }
           
           function drop_fields($tableName,$fieldNames){
                 return $this->query('ALTER TABLE '.$tableName.' drop ('.(is_array($fieldNames)?implode(',',$fieldNames) :$fieldNames).')');
           }
                                       
  }    
?>