<?php
  class dbOracle extends ADb{
      
          protected $dbType='Oracle';
          
           public function connect($DB,$USER,$PASSWORD,$DBNAME=FALSE){
                     $this->dbhost=$DB;
                      $this->dbuser=$USER;
                      $this->dbpass=$PASSWORD;
                      $this->dbname=$USER;
                      if ($this->check_exists('oci_connect'))
                      $this->link=@oci_connect($USER,$PASSWORD,$DB);
                      if (!$this->link) $this->error('Connection Error : '.$DB);
                      return $this->link;
                      
           }
      
           public function  query($sql){
                    parent::query($sql);
                    $query=@OCIParse($this->link,$this->lastSQL)  OR $this->error('Parse Error <hr>'.$sql.'<hr>'.$this->oci_error());
                           @OCIExecute($query);
                           return $this->lastQuery=$query;
           }
           
           private function oci_error($query=false){
               return @oci_error($query?$query:$this->lastQuery);
           }
           
           public function error($msg){
              echo parent::error($msg); 
           }
           
           public function fetch_assoc($query=false){
                    return @oci_fetch_assoc($query ? $query : $this->lastQuery);
           }
           
           public function fetch_row($query=false){
                   return @oci_fetch_row($query ? $query:$this->lastQuery);
           }
           
           public function fetch_all($query=false){
                $all=array();
                while($alls=$this->fetch_assoc()){
                        $all[]=$alls;
                }
                return $all;
           }
                  
           public function drop_table($tableName){
              return $this->query('DROP TABLE '.$tableName);
           }
           
           public function drop_fields($tableName,$fieldNames){
                 return $this->query('ALTER TABLE '.$tableName.' drop ('.(is_array($fieldNames)?implode(',',$fieldNames) :$fieldNames).')');
           }
           
           public function free($query=false){
               return @oci_free_statement($query?$query:$this->lastQuery);
           }
           
           public function close(){
               return @oci_close($this->link);
           }
                                       
  }    
?>