<?php 
   define('DB_ORACLE','Oracle'); 
   define('DB_MYSQL','Mysql'); 
   define('DB_MYSQLI','Mysqli'); 
   define('DB_MSSQL','Mssql');
   define('DB_INTERBASE','Interbae');
   define('DB_FIREBIRD','Firebird');
   define('DB_POSTGRESQL','PostgreSql');
    
   interface IDb{
        function connect($dbhost,$dbuser,$dbpass,$dbname=false);
        function query($sql);
        function fetch_row($query=False);
        function fetch_assoc($query=false);
        function fetch_object($query=false);
        function num_rows($query=false);
        function free($query=false);
        function drop_table($tableName);
        function drop_fields($tableName,$fieldNames);
        function table_exists($tableName);
        function field_exists($tableName,$fieldName);
        function fetch_all($query=false);
        function close();
   }            
?>